// Se importan las librerías necesarias.
#include <Wire.h>
#include <LiquidCrystal_I2C.h>
#include <HX711.h>
#include <Servo.h>
//Se declaran las variables necesarias.
const int DOUT=A1;
const int CLK=A0;
LiquidCrystal_I2C lcd(0x27,16,2); // si no te sale con esta direccion  puedes usar (0x3f,16,2) || (0x27,16,2)  ||(0x20,16,2) 
int cancion = 0;
volatile int numInterrupcion1   = 0;
boolean pause=0;
const int servo_pin= 9;
Servo servo;
HX711 balanza;

void setup() {
  attachInterrupt(digitalPinToInterrupt(2), funcionInterrupcion1, RISING);
  //Se inicializa el monitor serial y la LCD.
  Serial.begin(9600);
  lcd.init();
  lcd.backlight();
  lcd.clear();
  lcd.setCursor(0,0);
  servo.attach(servo_pin);
  balanza.begin(DOUT, CLK);
  //Se tara la balanza.
  Serial.print("Lectura del valor del ADC:  ");
  Serial.println(balanza.read());
  Serial.println("No ponga ningun  objeto sobre la balanza");
  Serial.println("Destarando...");
  Serial.println("...");
  balanza.set_scale(8800); // Establecemos la escala
  balanza.tare(20);  //El peso actual es considerado Tara.
  Serial.println("Listo para pesar");  
}

//Función de interrupción.
void funcionInterrupcion1() {
  static unsigned long ultimo_tiempo_de_interrupcion = 0;
  unsigned long tiempo_interrupcion            = millis();  
  if (tiempo_interrupcion - ultimo_tiempo_de_interrupcion > 500) {
    pause=!pause;
  }
}

//Función que imprime un vacio.
void impresion(){
  lcd.setCursor(0,1);
  lcd.print("                 ");
}
//Función que imprime el mensaje cuando se dispensa la comida.
void dispensar(){
  lcd.setCursor(0,1);
  lcd.print("Sirviendo comida");
}

//Función que activa el Servo Motor.
void motor() {
  servo.write(180);
  delay(1000);
  servo.write(0);
  delay(1000);
}


  void loop() {
    // Se imprime en la LCD el valor en la celda de carga.
    lcd.setCursor(0,0);
    lcd.print("Peso:");
    lcd.setCursor(6,0);
    lcd.print(balanza.get_units(20),2);
    lcd.setCursor(11,0);
    lcd.print("Kg");
    //Condicional
    if (pause==1){
      //Se llama la función dispensar.
      dispensar();
      //Se llama la función motor.
      motor(); 
      }
    else if (pause==0) {
      //Se llama la función impresion.
      impresion();
      }
    }
